"""Class for generating text/* type MIME documents.
"""

import MIMEBase



class Text(MIMEBase.MIMEBase):
    """Class for generating text/* type MIME documents."""

    def __init__(self, _text, _minor='plain', _charset="us-ascii"):
        """Create a text/* type MIME document.

        _text is the string for this message object.  If the text does not end
        in a newline, one is added.

        _minor is the minor content type, defaulting to "plain".

        _charset is the character set parameter added to the Content-Type:
        header.  This defaults to "us-ascii".
        """
        MIMEBase.MIMEBase.__init__(self, 'text', _minor,
                                   **{'charset': _charset})
        if _text[-1] <> '\n':
            _text += '\n'
        self.set_payload(_text)
