# Testing a completely manually generated message tree

import sys
import time

import Image
import Text
import Message
import Generator
import MIMEBase

fp = open('/home/bwarsaw/art/gif/bud')
idata = fp.read()
fp.close()

image = Image.Image(idata, name="bud.gif")
image.addheader('content-disposition', 'attachment', filename='bud.gif')

intro = Text.Text("""Hey Bud,

Here's a picture of you when you were a little kid.  I
hope you like it, it sure is funny!

Dub Yaw!""")

siggy = Text.Text("""--
good ol' Barry
""")

container = MIMEBase.MIMEBase('multipart', 'mixed')
container.add_payload(intro)
container.add_payload(image)
container.add_payload(siggy)

container['from'] = 'Albert Gore <gore@winner.com>'
container['to'] = 'Baby Boy Bush <cheater@stealme.com>'
container['subject'] = "Here's how you looked!"

timetuple = time.localtime(time.time())
if timetuple[-1] == 0:
    tzsecs = time.timezone
else:
    tzsecs = time.altzone
if tzsecs > 0:
    sign = '-'
else:
    sign = '+'
tzoffset = ' %s%04d' % (sign, tzsecs / 36)
container['date'] = time.strftime('%a, %d %b %Y %H:%M:%S',
                                  time.localtime(time.time())) + tzoffset


g = Generator.Generator(sys.stdout)
g.write(container)

import MsgReader
mi = MsgReader.MsgReader(container)
while 1:
    line = mi.readline()
    if not line:
        break
    print line[:-1]
