# Testing the parsing of an existing MIME message.

import sys

import Generator
import Parser
import Text

fp = open(sys.argv[1])

p = Parser.Parser()
msg = p.parse(fp)

# replace the image with a link to an image
if msg.ismultipart():
    newpayload = []
    for part in msg.get_payload():
        ctype = part.get('content-type')
        major, minor = None, None
        if ctype:
            try:
                major, minor = ctype.split('; ')[0].split('/')
            except ValueError:
                pass
        if major == 'image':
            # upload to image server, and get url
            part = Text.Text('''Use this URL instead: XXX.YYY''')
        newpayload.append(part)
    msg.set_payload(newpayload)

g = Generator.Generator(sys.stdout)
g.write(msg)
